﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows.Data;

namespace WpfApplication14.ViewModel
{
	public class VM : INotifyPropertyChanged
	{
		public VM()
		{
			peeps = new People();	
			lcv = new ListCollectionView(peeps);
			lcv.Filter = new Predicate<object>(p => PersonRelatesToQuery(p as Person, SearchQuery));
		}

		private People peeps;
		public People Peeps
		{
			get { return peeps; }
			set { peeps = value; }
		}

		ListCollectionView lcv;
		public ListCollectionView LCV
		{
			get { return lcv; }
			set { lcv = value; }
		}

		private string _searchQuery;
		public string SearchQuery
		{
			get { return _searchQuery; }
			set
			{
				_searchQuery = value;
				NotifyPropertyChanged("SearchQuery");
				// This line causes the error
				LCV.Refresh();
			}
		}

		public static bool PersonRelatesToQuery(Person p, string query)
		{
			if (string.IsNullOrEmpty(query))
				return true;

			if (p == null || p.Name == null)
				return false;

			return p.Name.ToUpperInvariant().Contains(query.ToUpperInvariant());
		}

		public event PropertyChangedEventHandler PropertyChanged;
		protected void NotifyPropertyChanged(string property)
		{
			var handler = PropertyChanged;
			if (handler != null) handler(this, new PropertyChangedEventArgs(property));
		}
	}
}
